class ColorImage{
public:
  int sx,sy;
  Image *R;
  Image *G;
  Image *B;
  ColorImage(char *filename){
    R = new Image();
    G = new Image();
    B = new Image();
    
    getPPM(R,G,B,filename);
    sx = R->sx;
    sy = R->sy;
  }
  ColorImage(int dsx,int dsy){
    sx = dsx;
    sy = dsy;
    R = new Image(sx,sy);
    G = new Image(sx,sy);
    B = new Image(sx,sy);
  }
  ~ColorImage(){
    delete R;
    delete G;
    delete B;
  }
  double BlackY(){
    return (0.299*255.0+0.587*255.0+0.114*255.0);
  
  }
  void RGB2YIQ(){
    int i,j;
    for(i=0;i<sy;i++)
      for(j=0;j<sx;j++){
	double Y = 0.299*R->img[i][j]+0.587*G->img[i][j]+0.114*B->img[i][j];
	double I = 0.596*R->img[i][j]-0.274*G->img[i][j]-0.322*B->img[i][j];
	double Q = 0.211*R->img[i][j]-0.522*G->img[i][j]+0.311*B->img[i][j];
	R->img[i][j] = Y;
	G->img[i][j] = I;
	B->img[i][j] = Q;
      }
  }
  void YIQ2RGB(){
    int i,j;
    for(i=0;i<sy;i++)
      for(j=0;j<sx;j++){
	double Rd = R->img[i][j]+0.956*G->img[i][j]+0.621*B->img[i][j];
	double Gd = R->img[i][j]-0.273*G->img[i][j]-0.647*B->img[i][j];
	double Bd = R->img[i][j]-1.107*G->img[i][j]+1.704*B->img[i][j];
	R->img[i][j] = Rd;
	G->img[i][j] = Gd;
	B->img[i][j] = Bd;
      }
  }
  
  void saveColorImagePPM(char *filename){
    savePPM(R,G,B,filename);
  }
  
};

class ColorGaussianPyramid{
 public:
  GaussianPyramid *R;
  GaussianPyramid *G;
  GaussianPyramid *B;
  int level,sx,sy;
  
  ColorGaussianPyramid(ColorImage *in){
    R = new GaussianPyramid(in->R);
    G = new GaussianPyramid(in->G);
    B = new GaussianPyramid(in->B);
    sx = in->sx;
    sy = in->sy;
    level = R->level;
    
  }
  ~ColorGaussianPyramid(){
    delete R;
    delete G;
    delete B;
  }

};
